// Generated by CoffeeScript 2.7.0
var _concat, _fill, _isBoolean, _isNumber, format, formatNumber, formatVertical, left, longDateFormat, parse, right, shortDateFormat, splitMaxlenStr, splitTrimNoEmpty, trimEnd;

trimEnd = function(str) {
  return str.replace(/\s+$/, '');
};

_isBoolean = function(value) {
  return typeof value === 'boolean';
};

_isNumber = function(value) {
  return typeof value === 'number' && !isNaN(value) && isFinite(value);
};

_fill = function(array, value) {
  var i, j, ref;
  for (i = j = 0, ref = array.length; (0 <= ref ? j < ref : j > ref); i = 0 <= ref ? ++j : --j) {
    array[i] = value;
  }
  return array;
};

_concat = function(array, ...rest) {
  var item, j, len1, result;
  result = array.slice(); // Create a shallow copy of the first array
  for (j = 0, len1 = rest.length; j < len1; j++) {
    item = rest[j];
    if (Array.isArray(item)) {
      result.push(...item);
    } else {
      result.push(item);
    }
  }
  return result;
};

formatNumber = function(number, format) {
  var decimalFormat, decimalPart, includeDollar, includeDollarSpace, intFormat, intPart, result;
  // Check for a dollar sign and set flag accordingly
  includeDollar = format.indexOf('$') !== -1;
  includeDollarSpace = format.indexOf('$ ') !== -1;
  format = format.replace(/\$\s?/, ''); // Remove dollar sign and optional space for processing
  
    // Split the format into integer and decimal parts
  [intFormat, decimalFormat] = format.split('.');
  // Format the integer part
  intPart = Math.floor(number).toString();
  intPart = intPart.replace(/\B(?=(\d{3})+(?!\d))/g, ',');
  // Format the decimal part if needed
  if (decimalFormat != null) {
    decimalPart = number.toFixed(decimalFormat.length).split('.')[1];
  } else {
    decimalPart = '';
  }
  // Combine the parts
  result = intPart;
  if (decimalPart) {
    result += '.' + decimalPart;
  }
  // Add dollar sign if required
  if (includeDollarSpace) {
    result = '$ ' + result;
  } else if (includeDollar) {
    result = '$' + result;
  }
  return result;
};

// split and remove all empty elements
splitTrimNoEmpty = function(line, splitChar) {
  var ar, j, len1, newAr, newstr, str;
  ar = line.split(splitChar);
  newAr = [];
  for (j = 0, len1 = ar.length; j < len1; j++) {
    str = ar[j];
    newstr = str.trim();
    if (newstr) {
      newAr.push(newstr);
    }
  }
  return newAr;
};

// returns an array with string split up by maxlen, if necessary
splitMaxlenStr = function(str, colMaxlen) {
  var ar, cutoff, pos, temp;
  ar = [];
  // go through all strings, checking for max length
  while (str.length > colMaxlen) {
    // find the first space back within 15 characters
    temp = str.substring(0, colMaxlen);
    pos = temp.lastIndexOf(' ');
    cutoff = colMaxlen - pos > 15 ? colMaxlen : pos;
    ar.push(str.substring(0, cutoff));
    // str = "↪  " + str.substring colMaxlen
    str = "   " + str.substring(cutoff + 1);
  }
  ar.push(str);
  return ar;
};

// return the first NUM characters
left = function(str, num) {
  return str.substr(0, num);
};

// return the last NUM characters
right = function(str, num) {
  return str.substr(str.length - num);
};

longDateFormat = function(date) {
  var ampm, day, hours, minutes, month, strTime, year;
  hours = date.getHours();
  minutes = date.getMinutes();
  ampm = hours >= 12 ? 'pm' : 'am';
  hours = hours % 12;
  hours = hours ? hours : 12; // the hour '0' should be '12'
  hours = hours < 10 ? '0' + hours : hours;
  minutes = minutes < 10 ? '0' + minutes : minutes;
  strTime = hours + ':' + minutes + ' ' + ampm;
  month = date.getMonth() + 1; // Months are zero based
  day = date.getDate();
  year = date.getFullYear();
  if (month < 10) {
    month = '0' + month;
  }
  if (day < 10) {
    day = '0' + day;
  }
  return `${month}/${day}/${year}  ${strTime}`;
};

shortDateFormat = function(date) {
  var ampm, day, hours, minutes, month, monthNames, strTime;
  monthNames = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
  hours = date.getHours();
  minutes = date.getMinutes();
  ampm = hours >= 12 ? 'pm' : 'am';
  hours = hours % 12;
  hours = hours ? hours : 12; // the hour '0' should be '12'
  minutes = minutes < 10 ? '0' + minutes : minutes;
  hours = hours < 10 ? '0' + hours : hours;
  strTime = hours + ':' + minutes + ' ' + ampm;
  month = monthNames[date.getMonth()];
  day = date.getDate();
  if (day < 10) {
    day = '0' + day;
  }
  return `${month} ${day}  ${strTime}`;
};

// input is an array of rows
// [
//		{col1: val, col2: val2}
//		{col1: val, col2: val2}
//		{col1: val, col2: val2}
// ]
// columns are built based on the keys of the first object
// options:
//		longdateformat: true/false, print the year for date fields?
//		meetInMiddle: right-justify even columns and left-justify odd columns
format = function(inputObj, options) {
  var ar, arIndex, arStr, betweenStr, borderline, bottomline, col, colIndex, colMaxlen, collen, columnHeaders, columnLengthArray, compactFlag, diff, excessRows, extra, formatfunc, headerStr, i, i1, isNumber, ix, j, j1, k, k1, key, keylen, keys, l, l1, len, len1, len10, len11, len12, len13, len14, len15, len16, len17, len18, len19, len2, len3, len4, len5, len6, len7, len8, len9, lineAr, linestr, longDashes, longStringOfSpaces, m, m1, n, n1, newRow, newStrAr, noheaders, numberformat, o, o1, obj, obj1, p, partsMax, q, r, ref, ref1, ref2, ref3, ref4, ref5, ref6, ref7, rlen, row, rowAr, rowIndex, s, sp, spacePad, spacePadLen, spstr, startLine, str, t, tempAr, topline, u, v, val, valueLineAr, w, x, y, z;
  options = options || {};
  compactFlag = options.compact;
  noheaders = options.noheaders;
  if (options.vertical) {
    return formatVertical(inputObj, options);
  }
  betweenStr = "│";
  startLine = "│";
  if (options.spaceDivider) {
    betweenStr = " ";
    startLine = " ";
  }
  lineAr = [];
  if (inputObj && inputObj.length) {
    // exclude columns
    if (options.excludeColumns && options.excludeColumns.length) {
      for (j = 0, len1 = inputObj.length; j < len1; j++) {
        obj1 = inputObj[j];
        ref = options.excludeColumns;
        for (k = 0, len2 = ref.length; k < len2; k++) {
          col = ref[k];
          delete obj1[col];
        }
      }
    }
    obj = inputObj[0];
    keys = Object.keys(obj);
    keylen = keys.length;
    partsMax = 1; // a "part" is a column name divided by "."
    isNumber = _fill(Array(keylen), false);
    columnHeaders = keys.map(function(key) {
      var ref1, ref2;
      if (options != null ? (ref1 = options.altHeaders) != null ? ref1[key] : void 0 : void 0) {
        return options != null ? (ref2 = options.altHeaders) != null ? ref2[key] : void 0 : void 0;
      } else {
        return key;
      }
    });
    // find the longest length of each column
    columnLengthArray = [];
    if (options.longdateformat) {
      formatfunc = longDateFormat;
    } else {
      // formatstr = 'mm/dd/yyyy  hh:MM tt'
      formatfunc = shortDateFormat;
    }
// formatstr = 'mmm dd  hh:MM tt'

    // seed the value with the column name
    for (i = m = 0, len3 = keys.length; m < len3; i = ++m) {
      key = keys[i];
      headerStr = (options != null ? (ref1 = options.altHeaders) != null ? ref1[key] : void 0 : void 0) || key;
      columnLengthArray[i] = 3;
      sp = headerStr.split(/[_\.]/);
      for (p = 0, len4 = sp.length; p < len4; p++) {
        str = sp[p];
        // set to the longest of the split parts
        columnLengthArray[i] = Math.max(columnLengthArray[i], str.length);
      }
      partsMax = Math.max(partsMax, sp.length);
    }
    // create array of arrays of values that all subsequent code will use
    colMaxlen = options.colMaxlen || 80;
    valueLineAr = [];
// n index
    for (n = q = 0, len5 = inputObj.length; q < len5; n = ++q) {
      obj = inputObj[n];
      rowAr = [];
      excessRows = [];
// o index
      for (o = r = 0, len6 = keys.length; r < len6; o = ++r) {
        key = keys[o];
        val = obj[key];
        if (Array.isArray(val)) {
          val = JSON.stringify(val);
        } else if (_isBoolean(val)) {
          val = val.toString();
        } else if (_isNumber(val)) {
          isNumber[o] = true;
          numberformat = options != null ? (ref2 = options.numberformat) != null ? ref2[key] : void 0 : void 0;
          if (numberformat) {
            // val = numeral(val).format numberformat
            val = formatNumber(val, numberformat);
          }
          val = val.toString().trim();
        } else {
          if (toString.call(val) === '[object Date]') {
            // val = dateformat val, formatstr
            val = formatfunc(val);
            val = val.replace(', 0', ',  ');
          }
          if (val == null) {
            val = '';
          }
          // split and see if we have more than one element
          sp = splitTrimNoEmpty(val, '\n');
          if (sp.length > 1) {
            // check string length
            ar = [];
// go through all strings, checking for max length
            for (s = 0, len7 = sp.length; s < len7; s++) {
              spstr = sp[s];
              if (spstr.length < colMaxlen) {
                ar.push(spstr);
              } else {
                ar = _concat(ar, splitMaxlenStr(spstr, colMaxlen));
              }
            }
            for (arIndex = t = 0, len8 = ar.length; t < len8; arIndex = ++t) {
              arStr = ar[arIndex];
              if (arIndex >= excessRows.length) {
                newRow = _fill(Array(keylen), '');
                excessRows.push(newRow);
              }
              newRow = excessRows[arIndex];
              newRow[o] = trimEnd(arStr);
            }
          } else if (val.length > colMaxlen) {
            ar = splitMaxlenStr(val, colMaxlen);
            for (arIndex = u = 0, len9 = ar.length; u < len9; arIndex = ++u) {
              arStr = ar[arIndex];
              if (arIndex >= excessRows.length) {
                newRow = _fill(Array(keylen), '');
                excessRows.push(newRow);
              }
              newRow = excessRows[arIndex];
              newRow[o] = trimEnd(arStr);
            }
          }
        }
        rowAr.push(val);
      }
      if (excessRows.length) {
        ref3 = excessRows[0];
        // console.log excessRows
        // merge with rowAr
        for (ix = v = 0, len10 = ref3.length; v < len10; ix = ++v) {
          str = ref3[ix];
          if (str) {
            rowAr[ix] = str;
          }
        }
        excessRows = excessRows.slice(1);
      }
      valueLineAr.push(rowAr);
      if (excessRows.length) {
        for (w = 0, len11 = excessRows.length; w < len11; w++) {
          row = excessRows[w];
          valueLineAr.push(row);
        }
      }
    }
    for (rowIndex = x = 0, len12 = valueLineAr.length; x < len12; rowIndex = ++x) {
      row = valueLineAr[rowIndex];
      for (colIndex = y = 0, len13 = row.length; y < len13; colIndex = ++y) {
        val = row[colIndex];
        val = val || '';
        columnLengthArray[colIndex] = Math.max(val.toString().length, columnLengthArray[colIndex]);
      }
    }
    longStringOfSpaces = '                                                                                                                                                                                                                                                                                                ';
    longDashes = '────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────';
    // print the column names
    // dotted columns names will be displayed in multiple lines
    linestr = startLine;
    newStrAr = [];
    for (i = z = 0, ref4 = partsMax; z < ref4; i = z += 1) {
      newStrAr.push(startLine);
    }
    borderline = startLine;
// l
    for (l = i1 = 0, len14 = keys.length; i1 < len14; l = ++i1) {
      key = keys[l];
      collen = columnLengthArray[l];
      // configure border line (top and bottom) first
      borderline += longDashes.slice(0, collen + 2) + betweenStr;
      tempAr = [];
      for (i = j1 = 0, ref5 = partsMax; j1 < ref5; i = j1 += 1) {
        tempAr.push('');
      }
      headerStr = (options != null ? (ref6 = options.altHeaders) != null ? ref6[key] : void 0 : void 0) || key;
      sp = headerStr.split(/[_\.]/);
      for (i = k1 = 0, len15 = sp.length; k1 < len15; i = ++k1) {
        str = sp[i];
        tempAr[i] = str;
      }
      // pop away blank lines, push everything down
      while (!tempAr[partsMax - 1]) {
        tempAr.pop();
        tempAr.unshift('');
      }
      for (i = l1 = 0, len16 = tempAr.length; l1 < len16; i = ++l1) {
        str = tempAr[i];
        // for blank strings, just output collen + 2
        if (!str.length) {
          newStrAr[i] += ' ' + longStringOfSpaces.slice(0, collen) + ' ' + betweenStr;
          continue;
        }
        spacePad = '';
        extra = '';
        if (collen !== str.length) {
          // padding needed
          diff = collen - str.length;
          spacePad = longStringOfSpaces.slice(0, (diff / 2));
          extra = longStringOfSpaces.slice(0, (diff % 2));
        }
        newStrAr[i] += ' ' + spacePad + str + extra + spacePad + ' ' + betweenStr;
      }
    }
    // console.log newStrAr

    // next two statement: total hacks
    // eliminate blank lines
    // while not trim newStrAr[newStrAr.length-1]
    // 	newStrAr.splice newStrAr.length-1,1

    // while not trim newStrAr[0]
    // 	newStrAr.splice 0,1
    columnHeaders = newStrAr.join('\n');
    // console.log columnHeaders, newStrAr
    if (!noheaders) {
      // lineAr.push linestr
      lineAr.push(columnHeaders);
      // print the dashes under the column names
      linestr = '├─';
      for (i = m1 = 0, len17 = keys.length; m1 < len17; i = ++m1) {
        key = keys[i];
        linestr += `${longDashes.slice(1, +columnLengthArray[i] + 1 || 9e9)}─${betweenStr}─`;
      }
      if (options.spaceDivider) {
        linestr = linestr.replace(/─\ ─/g, '─┼─');
        linestr = linestr.replace(/┼─$/g, '┤');
      } else {
        linestr = linestr.replace(/─│─/g, '─┼─');
        linestr = linestr.replace(/┼─$/g, '┤');
      }
      lineAr.push(linestr);
    }
// now cycle again and print result
// for obj, n in inputObj			# n index
// 	linestr = startLine+' '
// 	for key, o in keys 		# o index
// val = obj[key]
    for (rowIndex = n1 = 0, len18 = valueLineAr.length; n1 < len18; rowIndex = ++n1) {
      row = valueLineAr[rowIndex];
      linestr = startLine + ' ';
      for (colIndex = o1 = 0, len19 = row.length; o1 < len19; colIndex = ++o1) {
        val = row[colIndex];
        if (!val) {
          val = '';
        }
        key = keys[colIndex];
        if (isNumber[colIndex]) {
          val = val.toString().trim();
          len = val.length;
          // lineAr.push 'length, value, stored len: ', len, val, columnLengthArray[key]
          spacePadLen = columnLengthArray[colIndex] - len;
          // lineAr.push 'spacePadLen: ', spacePadLen
          spacePad = longStringOfSpaces.slice(1, +spacePadLen + 1 || 9e9);
          // linestr += spacePad+val.toString()+" | "
          if (options.meetInMiddle) {
            if (spacePad.length > 60) {
              spacePad = spacePad.substring(0, 60);
            }
          }
          if (options.meetInMiddle && o % 2 === 1) {
            // linestr += val+spacePad+"   "
            linestr += `${val}${spacePad} ${betweenStr} `;
          } else {
            linestr += `${spacePad}${val.toString()} ${betweenStr} `;
          }
        } else {
          spacePadLen = columnLengthArray[colIndex] + 1 - val.length;
          spacePad = longStringOfSpaces.slice(1, +spacePadLen + 1 || 9e9);
          // linestr += val+spacePad+"| "
          if (options.meetInMiddle) {
            if (spacePad.length > 60) {
              spacePad = spacePad.substring(0, 60);
            }
          }
          if (options.meetInMiddle && o % 2 === 0) {
            spacePad = longStringOfSpaces.slice(2, +spacePadLen + 1 || 9e9);
            // linestr += spacePad+val+betweenStr
            linestr += `${spacePad}${val}${betweenStr} `;
          } else if (((ref7 = options.align) != null ? ref7[key] : void 0) === 'right') {
            linestr += `${spacePad.slice(0, -1)}${val} ${betweenStr} `;
          } else {
            // linestr += val+spacePad+betweenStr
            linestr += `${val}${spacePad}${betweenStr} `;
          }
        }
      }
      linestr += betweenStr;
      // output the right bar to tne the string

      // final transformations

      // leave out the trailing |
      linestr = linestr.substr(0, linestr.length - 2);
      lineAr.push(linestr);
    }
    // add border lines
    if (options.spaceDivider) {
      topline = borderline.replace(/─\ ─/g, '─┬─');
      topline = topline.replace(/\ ─/g, '┌─');
      topline = topline.replace(/─\ /g, '─┐');
      bottomline = borderline.replace(/─\ ─/g, '─┴─');
      bottomline = bottomline.replace(/\ ─/g, '└─');
      bottomline = bottomline.replace(/─\ /g, '─┘');
    } else {
      topline = borderline.replace(/─│─/g, '─┬─');
      topline = topline.replace(/│─/g, '┌─');
      topline = topline.replace(/─│/g, '─┐');
      bottomline = borderline.replace(/─│─/g, '─┴─');
      bottomline = bottomline.replace(/│─/g, '└─');
      bottomline = bottomline.replace(/─│/g, '─┘');
    }
    lineAr.unshift(topline);
    if (options.title) {
      lineAr.unshift(options.title);
    }
    if (!compactFlag) {
      lineAr.unshift('');
    }
    lineAr.push(bottomline);
    if (!compactFlag) {
      rlen = inputObj.length;
      if (rlen === 1) {
        lineAr.push("  (1 row returned)");
      } else {
        lineAr.push(`  (${rlen} rows returned)`);
      }
      lineAr.push('');
    }
  } else {
    if (!compactFlag) {
      lineAr.push("  (0 rows returned)");
    }
  }
  return lineAr.join('\n');
};

// put keys on the left and data on the right
// no wrapping of data
// we only have 2 columns, the keys and the values
// each cell contains all the keys or all the values for that record
formatVertical = function(inputObj, options) {
  var allRows, ar, betweenStr, betweenline, borderline, bottomline, col, colAr, colMaxlen, collen, columnHeaders, columnLengthArray, columnNames, compactFlag, diff, extra, formatfunc, headerStr, i, i1, index, isNumber, item, j, j1, k, k1, key, keyMax, keys, keystr, l, len, len1, len10, len11, len12, len13, len14, len2, len3, len4, len5, len6, len7, len8, len9, lineAr, linestr, longDashes, longStringOfSpaces, m, n, newStrAr, numberformat, o, obj, obj1, p, partsMax, q, r, ref, ref1, ref2, ref3, ref4, ref5, rlen, row, s, sp, spacePad, spstr, startLine, str, t, tempAr, topline, u, v, val, valmax, valstr, valueAr, w, x, y, z;
  options = options || {};
  colMaxlen = options.colMaxlen || 70;
  betweenStr = "│";
  startLine = "│";
  compactFlag = options.compact;
  if (options.spaceDivider) {
    betweenStr = " ";
    startLine = " ";
  }
  lineAr = [];
  isNumber = [];
  if (inputObj && inputObj.length) {
    // exclude columns
    if (options.excludeColumns && options.excludeColumns.length) {
      for (j = 0, len1 = inputObj.length; j < len1; j++) {
        obj1 = inputObj[j];
        ref = options.excludeColumns;
        for (k = 0, len2 = ref.length; k < len2; k++) {
          col = ref[k];
          delete obj1[col];
        }
      }
    }
    obj = inputObj[0];
    // find the longest key
    keys = Object.keys(obj);
    keyMax = 1;
    for (m = 0, len3 = keys.length; m < len3; m++) {
      str = keys[m];
      keyMax = Math.max(keyMax, str.length);
    }
    keyMax = Math.max(keyMax, "Columns".length);
    keyMax += 2;
    if (options.longdateformat) {
      formatfunc = longDateFormat;
    } else {
      formatfunc = shortDateFormat;
    }
    // each "row" is an array of values
    // the "value" can be either a string or another array, in the case of multi-line
    allRows = [];
// n index
    for (n = p = 0, len4 = inputObj.length; p < len4; n = ++p) {
      obj = inputObj[n];
      colAr = [];
      valueAr = [];
// o index
      for (o = q = 0, len5 = keys.length; q < len5; o = ++q) {
        key = keys[o];
        ar = [];
        colAr.push(key + ':');
        val = obj[key];
        if (Array.isArray(val)) {
          val = JSON.stringify(val);
        } else if (_isBoolean(val)) {
          val = val.toString();
        } else if (_isNumber(val)) {
          isNumber[o] = true;
          numberformat = options != null ? (ref1 = options.numberformat) != null ? ref1[key] : void 0 : void 0;
          if (numberformat) {
            // val = numeral(val).format numberformat
            val = formatNumber(val, numberformat);
          }
          val = val.toString().trim();
        } else {
          if (toString.call(val) === '[object Date]') {
            val = formatfunc(val);
            val = val.replace(', 0', ',  ');
          }
          if (val == null) {
            val = '';
          }
          // split and see if we have more than one element
          // 		or if string is too long
          // if so, add the array instead of string value
          sp = splitTrimNoEmpty(val, '\n');
          if (sp.length > 1) {
// check string length

            // go through all strings, checking for max length
            for (r = 0, len6 = sp.length; r < len6; r++) {
              spstr = sp[r];
              if (spstr.length < colMaxlen) {
                ar.push(spstr);
              } else {
                ar = _concat(ar, splitMaxlenStr(spstr, colMaxlen));
              }
            }
          } else if (val.length > colMaxlen) {
            ar = splitMaxlenStr(val, colMaxlen);
          }
        }
        if (ar.length) {
          for (index = s = 0, len7 = ar.length; s < len7; index = ++s) {
            item = ar[index];
            if (index > 0) {
              colAr.push('');
            }
            valueAr.push(item);
          }
        } else {
          valueAr.push(val);
        }
      }
      allRows.push([colAr, valueAr]);
    }
    valmax = 1;
    for (t = 0, len8 = allRows.length; t < len8; t++) {
      row = allRows[t];
      valueAr = row[1];
      for (u = 0, len9 = valueAr.length; u < len9; u++) {
        val = valueAr[u];
        valmax = Math.max(valmax, val.length);
      }
    }
    valmax = Math.max(valmax, "Values".length);
    longStringOfSpaces = '                                                                                                                                                                                                                                                                                                ';
    longDashes = '────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────';
    // print the column names
    // dotted columns names will be displayed in multiple lines
    linestr = startLine;
    newStrAr = [];
    partsMax = 1; // we only have 1 line for column headers
    columnLengthArray = [keyMax, valmax];
    columnNames = ['Column', 'Values'];
    for (i = v = 0, ref2 = partsMax; v < ref2; i = v += 1) {
      newStrAr.push(startLine);
    }
    borderline = startLine;
// l
    for (l = w = 0, len10 = columnNames.length; w < len10; l = ++w) {
      key = columnNames[l];
      collen = columnLengthArray[l];
      // configure border line (top and bottom) first
      borderline += longDashes.slice(0, collen + 2) + betweenStr;
      tempAr = [];
      for (i = x = 0, ref3 = partsMax; x < ref3; i = x += 1) {
        tempAr.push('');
      }
      headerStr = (options != null ? (ref4 = options.altHeaders) != null ? ref4[key] : void 0 : void 0) || key;
      sp = headerStr.split(/[_\.]/);
      for (i = y = 0, len11 = sp.length; y < len11; i = ++y) {
        str = sp[i];
        tempAr[i] = str;
      }
      // pop away blank lines, push everything down
      while (!tempAr[partsMax - 1]) {
        tempAr.pop();
        tempAr.unshift('');
      }
      for (i = z = 0, len12 = tempAr.length; z < len12; i = ++z) {
        str = tempAr[i];
        // for blank strings, just output collen + 2
        if (!str.length) {
          newStrAr[i] += ' ' + longStringOfSpaces.slice(0, collen) + ' ' + betweenStr;
          continue;
        }
        spacePad = '';
        extra = '';
        if (collen !== str.length) {
          // padding needed
          diff = collen - str.length;
          spacePad = longStringOfSpaces.slice(0, (diff / 2));
          extra = longStringOfSpaces.slice(0, (diff % 2));
        }
        newStrAr[i] += ' ' + spacePad + str + extra + spacePad + ' ' + betweenStr;
      }
    }
    columnHeaders = newStrAr.join('\n');
    lineAr.push(columnHeaders);
    // print the dashes under the column names
    linestr = '├─';
    for (i = i1 = 0, len13 = columnNames.length; i1 < len13; i = ++i1) {
      key = columnNames[i];
      linestr += `${longDashes.slice(1, +columnLengthArray[i] + 1 || 9e9)}─${betweenStr}─`;
    }
    if (options.spaceDivider) {
      linestr = linestr.replace(/─\ ─/g, '─┼─');
      linestr = linestr.replace(/┼─$/g, '┤');
    } else {
      linestr = linestr.replace(/─│─/g, '─┼─');
      linestr = linestr.replace(/┼─$/g, '┤');
    }
    lineAr.push(linestr);
    betweenline = linestr;
    for (j1 = 0, len14 = allRows.length; j1 < len14; j1++) {
      row = allRows[j1];
      linestr = startLine + ' ';
      len = row[0].length; // how many lines for this row
      for (i = k1 = 0, ref5 = len; (0 <= ref5 ? k1 < ref5 : k1 > ref5); i = 0 <= ref5 ? ++k1 : --k1) {
        // right-justify column names, left justify values
        keystr = right(longStringOfSpaces + row[0][i], keyMax);
        valstr = left(row[1][i] + longStringOfSpaces, valmax);
        linestr = `${startLine} ${keystr} ${betweenStr} ${valstr} ${betweenStr}`;
        lineAr.push(linestr);
      }
      lineAr.push(betweenline);
    }
    // remove the last line
    lineAr.pop();
    // add border lines
    if (options.spaceDivider) {
      topline = borderline.replace(/─\ ─/g, '─┬─');
      topline = topline.replace(/\ ─/g, '┌─');
      topline = topline.replace(/─\ /g, '─┐');
      bottomline = borderline.replace(/─\ ─/g, '─┴─');
      bottomline = bottomline.replace(/\ ─/g, '└─');
      bottomline = bottomline.replace(/─\ /g, '─┘');
    } else {
      topline = borderline.replace(/─│─/g, '─┬─');
      topline = topline.replace(/│─/g, '┌─');
      topline = topline.replace(/─│/g, '─┐');
      bottomline = borderline.replace(/─│─/g, '─┴─');
      bottomline = bottomline.replace(/│─/g, '└─');
      bottomline = bottomline.replace(/─│/g, '─┘');
    }
    lineAr.unshift(topline);
    if (options.title) {
      lineAr.unshift(options.title);
    }
    if (!compactFlag) {
      lineAr.unshift('');
    }
    lineAr.push(bottomline);
    if (!compactFlag) {
      rlen = inputObj.length;
      if (rlen === 1) {
        lineAr.push("  (1 row returned)");
      } else {
        lineAr.push(`  (${rlen} rows returned)`);
      }
      lineAr.push('');
    }
  } else {
    if (!compactFlag) {
      lineAr.push("  (0 rows returned)");
    }
  }
  return lineAr.join('\n');
};

// given a string in table format, returns an array of objects
// uses the first line as properties for objects
parse = function(text) {
  var headerSeen, i, j, k, len1, len2, line, lineParts, lines, newObj, prop, propArray, retArray, val, valFound;
  retArray = [];
  headerSeen = false;
  propArray = [];
  lines = text.split('\n');
  for (i = j = 0, len1 = lines.length; j < len1; i = ++j) {
    line = lines[i];
    line = line.trim();
    if (line[0] === '#') {
      // if line starts with a comment, ignore it
      continue;
    }
    if (!line) {
      continue;
    }
    lineParts = line.split('|');
    if (lineParts.length < 3) {
      // vertical bar not found
      continue;
    }
    if (lineParts[1][0] === '-') {
      continue;
    }
    if (!headerSeen) {
      headerSeen = true;
      propArray = lineParts.slice(1).map(function(item) {
        return item.trim();
      }).filter(function(item) {
        return item !== '';
      });
      continue;
    }
    newObj = {};
    valFound = false;
    for (i = k = 0, len2 = propArray.length; k < len2; i = ++k) {
      prop = propArray[i];
      val = lineParts[i + 1].trim();
      if (!val) {
        continue;
      }
      newObj[prop] = val;
      valFound = true;
    }
    if (valFound) {
      retArray.push(newObj);
    }
  }
  return retArray;
};

exports.format = format;

exports.parse = parse;
